import { type MouseEvent } from 'react';
import { type TApplicationContext } from '@commercetools-frontend/application-shell-connectors';
import type { TFetchProjectQuery } from '../../types/generated/mc';
import type { TNavbarMenuGroup } from '../../types/generated/proxy';
type HookProps = {
    environment: TApplicationContext<{}>['environment'];
    project: TFetchProjectQuery['project'];
};
export type TMousePosition = {
    clientX: number;
    clientY: number;
};
declare const useNavbarStateManager: (props: HookProps) => {
    navBarNode: import("react").RefObject<HTMLElement | null>;
    handleToggleItem: (nextActiveItemIndex: string) => void;
    handleToggleMenu: () => void;
    shouldCloseMenuFly: (e: React.MouseEvent<HTMLElement> | MouseEvent | FocusEvent) => void;
    getMousePosition: (e: MouseEvent<HTMLLIElement>, itemIndex: string) => void;
    allApplicationsNavbarMenuGroups: TNavbarMenuGroup[];
    activeItemIndex?: string | undefined;
    isExpanderVisible: boolean;
    isMenuOpen: boolean;
    mousePosition: TMousePosition;
};
export default useNavbarStateManager;
