import type { RouteComponentProps } from 'react-router-dom';
import { LOGOUT_REASONS } from '@commercetools-frontend/constants';
type TQueryParams = {
    reason?: (typeof LOGOUT_REASONS)[keyof typeof LOGOUT_REASONS];
    redirectTo?: string;
    client_id?: string;
    response_type?: string;
    scope?: string;
    state?: string;
    nonce?: string;
};
type TRedirectorProps = {
    to: string;
    origin?: string;
    location?: RouteComponentProps['location'];
    queryParams?: TQueryParams;
};
declare const useRedirector: () => (options: TRedirectorProps) => void;
declare const Redirector: {
    (props: TRedirectorProps): null;
    displayName: string;
};
export { useRedirector, Redirector };
